{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": "cat",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {},
                    "id": "#cat.cwl/cat_in"
                }
            ],
            "stdout": "all.txt",
            "id": "#cat.cwl",
            "outputs": [
                {
                    "type": "File",
                    "id": "#cat.cwl/txt",
                    "outputBinding": {
                        "glob": "all.txt"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "echo",
            "inputs": [
                {
                    "type": [
                        "string",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {},
                    "id": "#echo.cwl/echo_in"
                }
            ],
            "stdout": "out.txt",
            "outputs": [
                {
                    "type": "File",
                    "id": "#echo.cwl/txt",
                    "outputBinding": {
                        "glob": "out.txt"
                    }
                }
            ],
            "id": "#echo.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "string",
                        "int"
                    ],
                    "default": "a0",
                    "id": "#main/letters0"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "a1",
                        "b1"
                    ],
                    "id": "#main/letters1"
                },
                {
                    "type": [
                        "string",
                        "int"
                    ],
                    "default": "a2",
                    "id": "#main/letters2"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "a3",
                        "b3"
                    ],
                    "id": "#main/letters3"
                },
                {
                    "type": "string",
                    "default": "a4",
                    "id": "#main/letters4"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "a5",
                        "b5",
                        "c5"
                    ],
                    "id": "#main/letters5"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/cat/txt",
                    "id": "#main/all"
                }
            ],
            "steps": [
                {
                    "run": "#cat.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/echo_w/txt",
                                "#main/echo_x/txt",
                                "#main/echo_y/txt",
                                "#main/echo_z/txt"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/cat/cat_in"
                        }
                    ],
                    "out": [
                        "#main/cat/txt"
                    ],
                    "id": "#main/cat"
                },
                {
                    "run": "#echo.cwl",
                    "in": [
                        {
                            "source": "#main/letters0",
                            "id": "#main/echo_w/echo_in"
                        }
                    ],
                    "out": [
                        "#main/echo_w/txt"
                    ],
                    "id": "#main/echo_w"
                },
                {
                    "run": "#echo.cwl",
                    "scatter": "#main/echo_x/echo_in",
                    "in": [
                        {
                            "source": [
                                "#main/letters1",
                                "#main/letters2"
                            ],
                            "linkMerge": "merge_nested",
                            "id": "#main/echo_x/echo_in"
                        }
                    ],
                    "out": [
                        "#main/echo_x/txt"
                    ],
                    "id": "#main/echo_x"
                },
                {
                    "run": "#echo.cwl",
                    "scatter": "#main/echo_y/echo_in",
                    "in": [
                        {
                            "source": [
                                "#main/letters3",
                                "#main/letters4"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/echo_y/echo_in"
                        }
                    ],
                    "out": [
                        "#main/echo_y/txt"
                    ],
                    "id": "#main/echo_y"
                },
                {
                    "run": "#echo.cwl",
                    "in": [
                        {
                            "source": "#main/letters5",
                            "valueFrom": "special value parsed in valueFrom",
                            "id": "#main/echo_z/echo_in"
                        }
                    ],
                    "out": [
                        "#main/echo_z/txt"
                    ],
                    "id": "#main/echo_z"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
